<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <!-- The above 3 meta tags *must* come first in the head; any other head content must come *after* these tags -->
    <title class="browserTitle"></title>

    <!-- Latest compiled and minified CSS -->
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@5.3.3/dist/css/bootstrap.min.css" integrity="sha384-QWTKZyjpPEjISv5WaRU9OFeRpok6YctnYmDr5pNlyT2bRjXh0JMhjY6hW+ALEwIH" crossorigin="anonymous">

    <!-- Boostrap Icons -->
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap-icons@1.10.3/font/bootstrap-icons.css">

    <!-- Optional theme -->
    <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=PT+Sans">
    <link rel="stylesheet" type="text/css" href="css/layout.css">

    <!-- HTML5 shim and Respond.js for IE8 support of HTML5 elements and media queries -->
    <!-- WARNING: Respond.js doesn't work if you view the page via file:// -->
    <!--[if lt IE 9]>
        <script src="https://oss.maxcdn.com/html5shiv/3.7.3/html5shiv.min.js"></script>
        <script src="https://oss.maxcdn.com/respond/1.4.2/respond.min.js"></script>
    <![endif]-->

    <!-- Popper (necessary for Bootstrap's tooltips) -->
    <script src="https://cdn.jsdelivr.net/npm/@popperjs/core@2.11.8/dist/umd/popper.min.js" integrity="sha384-I7E8VVD/ismYTF4hNIPjVp/Zjvgyol6VFvRkX/vR+Vc4jQkC+hVqc2pM8ODewa9r" crossorigin="anonymous"></script>
    <!-- Latest compiled and minified JavaScript -->
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.3.3/dist/js/bootstrap.min.js"
integrity="sha384-0pUGZvbkm6XF6gxjEnlmuGrJXVbNuzT9qBBavbLwCsOGabYfZo0T0to5eqruptLy" crossorigin="anonymous"></script>

    <script src="https://cdnjs.cloudflare.com/ajax/libs/lodash.js/4.17.21/lodash.min.js" integrity="sha512-WFN04846sdKMIP5LKNphMaWzU7YpMyCU245etK3g/2ARYbPK9Ub18eG+ljU96qKRCWh+quCY7yefSmlkQw1ANQ==" crossorigin="anonymous" referrerpolicy="no-referrer"></script>

    <script type="text/javascript" src="js/fapi.ui.js"></script>

</head>
<body>

    <div class="pageHeader container-fluid">
        <div class="row">
            <div class="col-md-8">
                <a href="index.html"><img src="/images/openid.png"></a>
            </div>
            <div id="userInfoHolder" class="col-md-4"></div>
        </div>
    </div>
    <div class="clearfix"></div>

    <!-- error modal -->
    <div class="modal" id="errorModal" tabindex="-1" role="dialog" aria-labelledby="errorLabel">
        <div class="modal-dialog" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <h4 class="modal-title" id="errorLabel">Error</h4>
                    <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
                </div>
                <div class="modal-body">
                    Error: <span id="errorMessage"></span>
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-sm btn-light bg-gradient border border-secondary" data-bs-dismiss="modal">Close</button>
                </div>
            </div>
        </div>
    </div>

    <!-- loading modal -->
    <div class="modal" id="loadingModal" tabindex="-1" role="dialog" aria-labelledby="errorLabel" data-bs-backdrop="static" data-bs-keyboard="false">
        <div class="modal-dialog modal-sm" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <h4 class="modal-title" id="loadingLabel">Loading...</h4>
                </div>
                <div class="modal-body">
                    <div class="text-center">
                        <img src="/images/spinner.gif" width="100px" height="30px" />
                    </div>
                    <div>
                        <span id="loadingMessage"></span>
                    </div>
                </div>
            </div>
        </div>
    </div>

    <div class="container-fluid">
        <div id="viewRunningTestPage">
            <div class="row">
                <div class="col-md-12">
                    <h3>Running tests</h3>
                </div>
            </div>
            <div class="row">
                <div class="col-md-2">
                    <div class="d-grid">
                        <button class="btn btn-sm btn-light bg-gradient border border-secondary" id="refresh">
                            <span class="bi bi-arrow-repeat"></span> Refresh
                        </button>
                    </div>
                </div>

                <div class="col-md-10" id="running-tests">
                    <!-- running tests get attached here -->
                </div>
            </div>

        </div>
    </div>

    <script type="text/javascript">
        document.addEventListener("DOMContentLoaded", () => {

            FAPI_UI.loadRunningTestPageTemplates()
            .then(function() {
                return FAPI_UI.getUserInfo();
            }).then(function() {
                return loadRunningTest();
            }).then(function() {
                return loadServerInfo();
            });
        });

        function loadRunningTest() {
            document.getElementById('refresh').onclick = function(event) {
                updateRunningTable();
            };

            // refresh the running table right now
            updateRunningTable();
        }

        /**
         *
         */
        function updateRunningTable() {
            return fetch('/api/runner/running')
                .then((response) => response.json())
                .then((data) => {
                    //console.log('running: ', JSON.stringify(data));
                    document.getElementById('running-tests').innerHTML = "";

                    var promise = Promise.resolve();

                    _.each(data, function(testId) {
                        //console.log('getting: ' + testId);
                        promise = promise.then(() => {
                            return getRunningTest(testId);
                        });
                    });

                    promise.then(() => {
                        FAPI_UI.activeTooltip();
                    });
                })
        }

        function getRunningTest(testId) {
            return fetch('/api/runner/' + encodeURIComponent(testId))
                .then((response) => response.json())
                .then((data) => {
                    var runningTest = FAPI_UI.logTemplates.RUNNING_TEST({
                        test: data
                    });

                    var runningTestsElement = document.getElementById('running-tests');
                    runningTestsElement.insertAdjacentHTML('beforeend', runningTest);

                    runningTestsElement.querySelector('[data-instance-id="' + testId + '"]').querySelector('.downloadBtn').onclick = function(evt) {
                        evt.preventDefault();
                        window.open('/api/log/' + encodeURIComponent(testId) + '?dl=true');
                    };

                }).then(function() {
                    return fetch('/api/info/' + encodeURIComponent(testId))
                    .then((response) => {
                        if (!response.ok) {
                            return Promise.reject(response);
                        }

                        return response.json();
                    })
                    .then((data) => {
                        var testElement = document.querySelector('[data-instance-id="' + testId + '"]')

                        testElement.querySelector('.testStatusAndResult').innerHTML = FAPI_UI.logTemplates.TEST_STATUS({test: data});
                        FAPI_UI.activeTooltip();
                    })
                    .catch((error) => {
                        if (error instanceof Response) {
                            // We have a 'Respose' object.
                            var message = error.statusText;
                            var responseClone = error.clone();

                            error.text()
                            .then(textError => {
                                // Text error thrown by the app
                                messageParsed = true;

                                try {
                                    const errorObj = JSON.parse(textError);

                                    if (errorObj.error.length != 0) {
                                        message = errorObj.error;
                                    }
                                }
                                catch (e) {
                                }

                                FAPI_UI.showError({code: error.status.toString(), error: message});
                            })
                            .catch(error1 => {
                                // JSON error thrown by the app
                                responseClone.json()
                                .then(jsonError => {
                                    if (typeof (jsonError) === 'string' && jsonError.length != 0) {
                                        message = jsonError;
                                    }

                                    FAPI_UI.showError({code: error.status.toString(), error: message});
                                })
                                .catch(genericError => {
                                    // Error thrown by the server
                                    FAPI_UI.showError({code: error.status.toString(), error: error.statusText});
                                });
                            });
                        } else {
                            // Network error automatically detected by fetch.
                            FAPI_UI.showError({code: "", error: error});
                        }
                    });
                });
        }

        function loadServerInfo() {
            return fetch('/api/server')
                .then((response) => response.json())
                .then((data) => {
                    const browserTitle = document.querySelector('.browserTitle');
                    browserTitle.textContent = `${data.brand} Functional Conformance: Login`;

                    const serverInfo = document.querySelector('.serverInfo');

                    const textStr =
                        [(data.hasOwnProperty("external_ip") ? "External IP: " + data.external_ip:""),
                         (data.hasOwnProperty("version") ? "Version: " +data.version:"")].filter(Boolean).join(" - ");
                    serverInfo.textContent = textStr;

                    const brandDesc = document.querySelector('.brandDesc');
                    brandDesc.textContent = `${data.brand} Functional Conformance Suite - Brought to you by Raidiam, with thanks to the OpenID Foundation`;

                    const logo = document.querySelector('#logo');
                    logo.src = `/images/${data.logo}`;
                });
        }
    </script>

    <footer class="pageFooter">
		<div class="row">
			<span class="muted"><div class="brandDesc"></div><br /></span>
			<span class="muted"></span><a href="https://raidiam.com"><img src="/images/raidiam.png" width="285" height="32"></a></span>
		</div>
    </footer>
</body>
</html>
